segment .data
  
  enter$    db "Enter something:",0
  nbytes$   db "Number of bytes entered:%d%c",0
  string$   db "String entered:%s%c",0
  press$    db "Press any key to exit...",0
  
  buffer    db 20           ; length of input buffer
            db 0            ; byte to hold returned length
            times 20 db 0   ; space for the string
            db 0            ; null terminator

segment .text

%stacksize flat

; These are all C functions from MSVCRT.DLL:

extern printf,_cgets,_kbhit,_getch,exit

; For the C calling convention the parameters are pushed
; onto the stack in right to left order as they appear in
; the function prototype, and the caller is responsible
; for removing the parameters from the stack, normally
; done by adding 4 * (the number of parameters) to esp.
;
; For the STDCALL calling convention that is used by all
; but one of the Windows API functions, the parameters
; are pushed in right to left order as they appear in
; the function prototype, and the called function is
; responsible for removing the parameters from the stack.

Start:

    push  enter$
    call  printf
    add   esp, 4

    push  buffer
    call  _cgets
    add   esp, 4
    
    movzx eax, BYTE[buffer+1]
    push  10
    push  eax
    push  nbytes$
    call  printf
    add   esp, 12
    
    push  10
    push  buffer+2
    push  string$
    call  printf
    add   esp, 12

    push  press$
    call  printf
    add   esp, 4

  ; This code flushes the input buffer, waits for a
  ; keystroke, and flushes the buffer again, leaving
  ; it empty.

  flushloop:
    call  _kbhit
    or    eax, eax
    jz    waitloop
    call  _getch
    jmp   flushloop
  waitloop:
    call  _getch
    call  _kbhit
    or    eax, eax
    jnz   waitloop

    call exit




